; *****************************************************************************
; *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
; *                                                                            
; * x-symbol-holocl-font.el  - font defintion for HOL-OCL x-symbol minor mode
; * Copyright (C) 2005 Achim D. Brucker <brucker@inf.ethz.ch>   
; *                                                                            
; * This file is part of HOL-OCL.                                              
; *                                                                            
; * HOL-OCL is free software; you can redistribute it and/or modify it under   
; * the terms of the GNU General Public License as published by the Free       
; * Software Foundation; either version 2 of the License, or (at your option)  
; * any later version.                                                         
; *                                                                            
; * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
; * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
; * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
; * details.                                                              
; *                                                                            
; * You should have received a copy of the GNU General Public License along    
; * with this program; if not, write to the Free Software Foundation, Inc.,    
; * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
; ******************************************************************************
(provide 'x-symbol-holocl-font)

(add-to-list 'x-symbol-group-input-alist '(HolOclLifting 100)) 	
(add-to-list 'x-symbol-group-input-alist '(MathOclLogic 121)) 	
(add-to-list 'x-symbol-group-input-alist '(MathOclNumerals 123)) 	
(add-to-list 'x-symbol-group-input-alist '(MathOclCollection 124)) 	
(add-to-list 'x-symbol-group-input-alist '(MathOclOclAny 125))
(add-to-list 'x-symbol-group-input-alist '(MathOclString 126))
(add-to-list 'x-symbol-group-input-alist '(MathOclVoid 127))
 

(defvar x-symbol-holocl0-table
  '(;;(exclam1 33)			; Adobe:exclam
;    (OCLuniversal 34 (MathOclCollection) nil nil ("A"))
 ;  (OCLnumbersign1 35 (symbol) nil nil ("#")) ; Adobe:numbersign, TeX
 ;   (OCLexistential 36 (MathOclCollection) nil nil ("E"))
    ;;(percent1 37 (symbol) nil nil ("%"))	; Adobe:percent
    ;;(ampersand1 38 (symbol) nil nil ("&"))
 ;   (OCLsuchthat 39 (relation) (direction east . element) nil ("-)"))
    ;;(parenleft1 40)			; Adobe:parenleft
    ;;(parenright1 41)			; Adobe:parenright
 ;   (OCLasterisk1 42 (operator) nil nil ("*")) ; Adobe:asteriskmath
    ;;(plus1 43)				; Adobe:plus
    ;;(comma1 44 (quote) nil (","))	; Adobe:comma
 ;   (OCLminus1 45 (operator) nil nil ("-"))	; Adobe:minus
 ;   (OCLperiod1 46 (dots) nil nil ("."))	; Adobe:period
    ;;(slash1 47)				; Adobe:slash
    ;; 48..57 = ascii 0-9
 ;   (OCLcolon1 58 (dots) nil nil (":"))	; Adobe:colon, TeX
    ;;(semicolon1 59)			; Adobe:semicolon
    ;;(less1 60 (relation) (direction west . greater1) nil ("<"))
    ;;(equal1 61)				; Adobe:equal
    ;;(greater1 62 (relation) (direction east) nil (">"))
    ;;(question1 63)			; Adobe:question
 ;   (OCLcongruent 64 (relation) nil nil (t "~="))
 ;   (OCLDelta 68 (greek "D" delta "Delta"))
 ;   (OCLPhi 70 (greek "F" phi "Phi"))
 ;   (OCLGamma 71 (greek "G" gamma "Gamma"))
 ;   (OCLtheta1 74 (greek1 "q" Theta "theta"))
 ;   (OCLLambda 76 (greek "L" lambda "Lambda"))
 ;   (OCLPi 80 (greek "P" pi "Pi"))
 ;   (OCLTheta 81 (greek "Q" theta "Theta"))
 ;   (OCLSigma 83 (greek "S" sigma "Sigma"))
 ;   (OCLsigma1 86 (greek1 "s" Sigma "sigma"))
 ;   (OCLOmega 87 (greek "W" omega "Omega"))
 ;   (OCLXi 88 (greek "X" xi "Xi"))
 ;   (OCLPsi 89 (greek "Y" psi "Psi"))
    ;;(bracketleft1 91)			; Adobe:bracketleft
    ;;(therefore 92 (dots) (direction nil . ellipsis) nil (".:"))
    ;;(bracketright1 93)			; Adobe:bracketright
; (OCLperpendicular 94 (MathOclLogic) (direction north) nil (t "_|_")) ; (TeX)
 ;   (OCLunderscore1 95 (line) nil nil ("_"))	; Adobe:underscore, TeX
 ;   (OCLradicalex 96 (line) (shift up) nil ("-^" "^-"))
 ;   (OCLalpha 97 (greek "a" nil "alpha"))
 ;   (OCLbeta 98 (greek "b" nil "beta"))
 ;   (OCLchi 99 (greek "c" nil "chi"))
 ;(OCLdelta 100 (MathOclOclAny)  nil nil (t "Ocld"))
 ;   (OCLepsilon 101 (greek "e" nil "epsilon"))
 ;   (OCLphi 102 (greek "f" Phi "phi"))
 ;   (OCLgamma 103 (greek "g" Gamma "gamma"))
 ;   (OCLeta 104 (greek "h" nil "eta"))
 ;   (OCLiota 105 (greek "i" nil "iota"))
 ;   (OCLphi1 106 (greek1 "f" Phi "phi"))
 ;   (OCLkappa 107 (greek "k" nil "kappa"))
 ;   (OCLlambda 108 (greek "l" Lambda "lambda"))
 ;   (OCLmu 109 (greek "m" nil "mu"))
 ;   (OCLnu 110 (greek "n" nil "nu"))
 ;   (OCLpi 112 (greek "p" Pi "pi"))
 ;   (OCLtheta 113 (greek "q" Theta "theta"))
 ;   (OCLrho 114 (greek "r" nil "rho"))
 ;   (OCLsigma 115 (greek "s" Sigma "sigma"))
 ;   (OCLtau 116 (greek "t" nil "tau"))
 ;   (OCLupsilon 117 (MathOclOclAny) nil nil (t "upsilon"))
 ;   (OCLomega1 118 (greek1 "w" Omega "omega"))
 ;   (OCLomega 119 (greek "w" Omega "omega"))
 ;   (OCLxi 120 (greek "x" Xi "xi"))
 ;   (OCLpsi 121 (greek "y" Psi "psi"))
 ;   (OCLzeta 122 (greek "z" nil "zeta"))
;;; ;   (OCLbraceleft1 123 (parenthesis open braceright1)
;;;		(direction west . braceright1) nil ("{"))
 ;   (OCLbar1 124 (line) brokenbar 120 ("|"))	; Adobe:bar, TeX
;;; ;   (OCLbraceright1 125 (parenthesis close braceleft1) (direction east) nil ("}"))
 ;   (OCLsimilar 126 (relation) nil nil ("~"))
 ;   (OCLUpsilon1 161 (greek1 "U" upsilon "Upsilon"))
 ;   (OCLminute 162 (symbol) nil nil ("'"))
 ;   (OCLlessequal 163 (relation) (direction west . greaterequal) nil (t "<_"))
 ;   (OCLfraction 164 (operator) nil nil ("/"))
 ;   (OCLinfinity 165 (symbol) nil nil ("oo"))
 ;   (OCLflorin 166 (currency "f") nil nil ("f"))
 ;   (OCLclub 167 (shape) (direction north . diamond) nil ("{#}"))
 ;   (OCLdiamond 168 (shape) (direction east . lozenge) nil ("<#>"))
 ;   (OCLheart 169 (shape) (direction south . diamond) nil ("(#)"))
 ;   (OCLspade 170 (shape) (direction west . diamond) nil ("/#\\"))
 ;   (OCLarrowboth 171 (arrow) (direction horizontal . arrowright) nil
;	       (t "<->") (arrowleft))
 ;   (OCLarrowleft 172 (arrow) (direction west . arrowright) nil (t "<-"))
 ;   (OCLarrowup 173 (arrow) (direction north . arrowright) nil ("|^"))
 ;   (OCLarrowright 174 (arrow) (direction east) nil (t "->"))
 ;   (OCLarrowdown 175 (arrow) (direction south . arrowright) nil ("|v"))
 ;   (OCLring 176 (ring accent))		; Adobe:degree, TeX
    ;;(plusminus1 177)			; Adobe:plusminus
 ;   (OCLsecond 178 (symbol) nil nil ("''"))		; NEW
 ;   (OCLgreaterequal 179 (relation) (direction east) nil (t ">_"))
    ;;(times1 180)				; Adobe:times
 ;   (OCLproportional 181 (relation) nil nil ("oc"))
 ;    (OCLpartialdiff 182 (MathOclOclAny) nil nil ("d"))
 ;   (OCLbullet 183 (operator) nil 240 ("*"))
    ;;(divide1 184)			; Adobe:divide
 ;   (OCLnotequal 185 (relation) nil nil (t "=/"))
 ;   (OCLequivalence 186 (relation) nil nil (t "=_"))
 ;   (OCLapproxequal 187 (relation) nil nil (t "~~"))
 ;   (OCLellipsis 188 (dots) (direction east) nil (t "..."))
    ;;(arrowhorizex 190 (line) (size big) nil ("-"))
 ;   (OCLcarriagereturn 191 (arrow) (direction west) nil ("<-|"))	; NEW
 ;   (OCLaleph 192 (mathletter "N"))
 ;   (OCLIfraktur 193 (mathletter "I"))
 ;   (OCLRfraktur 194 (mathletter "R"))
 ;   (OCLweierstrass 195 (mathletter "P"))
 ;   (OCLcirclemultiply 196 (operator) nil nil (t "xO") (multiply))
 ;   (OCLcircleplus 197 (MathOclLogic) nil nil (t "O+O"))
 ;   (OCLemptyset 198 (shape) nil nil ("Eset"))
 ;   (OCLintersection 199 (MathOclCollection) nil nil ("In"))
 ;   (OCLunion 200 (MathOclCollection) nil nil ("Un"))
 ;   (OCLpropersuperset 201 (relation) (direction east . union) nil (">"))
 ;   (OCLreflexsuperset 202 (relation) (shape round . greaterequal) nil
;		    nil (propersuperset))
 ;   (OCLnotsubset 203 (relation) (shape round direction west) nil
;	       ("</") (propersubset))
 ;   (OCLpropersubset 204 (relation) (direction west . propersuperset) nil ("<"))
 ;   (OCLreflexsubset 205 (relation) (shape round . lessequal) nil
;		  nil (propersubset))
;    (OCLelement 206 (MathOclCollection) (direction west) nil ("(--"))
;    (OCLnotelement 207 (MathOclCollection) (direction west) nil (t "(--/") (element))
 ;   (OCLangle 208 (symbol) nil nil ("/_"))
 ;   (OCLgradient 209 (triangle) (direction south . Delta) nil (t "\\-/"))
    ;;(register1 210)			; Adobe:registerserif
    ;;(copyright1 211)			; Adobe:copyrightserif
    ;;(trademark1 212)			; Adobe:trademarkserif
 ;   (OCLproduct 213 (bigop) (size big . Pi) nil ("TT"))
 ;   (OCLradical 214 (symbol) nil nil ("v/"))
 ;   (OCLperiodcentered1 215 (dots) periodcentered 120) ; Adobe:dotmath, (TeX)
 ;   (OCLlogicalnot1 216 (MathOclLogic) nil nil (t "|--"))			; Adobe:logicalnot
 ;   (OCLlogicaland 217 (MathOclLogic) (direction north . OCLlogicalor) nil (t "//\\"))
 ;   (OCLlogicalor 218 (MathOclLogic) (direction south) nil (t "\\//"))
 ;   (OCLarrowdblboth 219 (arrow) (direction horizontal . arrowdblright) nil
;		  (t "<=>") (arrowdblleft))
 ;   (OCLarrowdblleft 220 (arrow) (direction west . arrowdblright) nil (t "<="))
 ;   (OCLarrowdblup 221 (arrow) (direction north . arrowdblright) nil ("||^"))
 ;   (OCLarrowdblright 222 (arrow) (direction east) nil (t "=>"))
 ;   (OCLarrowdbldown 223 (arrow) (direction south . arrowdblright) nil ("||v"))
 ;   (OCLlozenge 224 (shape) nil nil ("<>"))
 ;   (OCLangleleft 225 (parenthesis open angleright)
	    ;   (OCLdirection west . angleright) 120 ("{"))
    ;;(registered2 226)			; Adobe:registersans
    ;;(copyright2 227)			; Adobe:copyrightsans
 ;   (OCLtrademark 228 (symbol "T") nil nil ("TM"))	; Adobe:trademarksans
 ;   (OCLsummation 229 (bigop) (size big . Sigma))
 ;   (OCLangleright 241 (parenthesis close angleleft) (direction east) 120 ("}"))
 ;   (OCLintegral 242 (bigop) (size big) nil (t "|'"))
)
  "Table for registry \"fontspecific\", see `x-symbol-init-cset'.")






(defvar x-symbol-holocl1-table
  '(
 ;; Caution: range  0-33 is forbidden
    (OclImplies     33 (MathOclLogic)     nil nil ("MathOclImplies"))
    (OclVImplies    34 (MathOclLogic)     nil nil ("MathOclImpliesV"))
    (OclVVImplies   35 (MathOclLogic)     nil nil ("MathOclImpliesVV"))
    (OclSImplies    36 (MathOclLogic)     nil nil ("MathOclSImplies"))
;    (Ocl_          37  (MathOclSymbol) nil nil ("OCLif"))
    (OclLiftLeft    38 (HolOclLifting)    nil nil ("HolOclLiftLeft"))
    (OclLiftRight   39 (HolOclLifting)    nil nil ("HolOclLiftRight"))

    (OclDropLeft    40 (HolOclLifting)    nil nil ("HolOclDropLeft"))
    (OclDropRight   41 (HolOclLifting)    nil nil ("HolOclDropRight"))
    (OclFloorLeft   42  (MathOclNumerals) nil nil ("MathOclFloorLeft"))
    (OclFloorRight  43  (MathOclNumerals) nil nil ("MathOclFloorRight"))
    (OclRoundLeft   44  (MathOclNumerals) nil nil ("MathOclRoundLeft"))
    (OclRoundRight  45  (MathOclNumerals) nil nil ("MathOclRoundRight"))
;    (OCL_ 46  (MathOclSymbol) nil nil ("OCLif"))
;    (OCL_ 47  (MathOclSymbol) nil nil ("OCLif"))
    (OclIf          48  (MathOclLogic)    nil nil ("MathOclIf"))
    (OlcThen        49  (MathOclLogic)    nil nil ("MathOclThen"))
    (OclElse        50  (MathOclLogic)    nil nil ("MathOclElse"))
    (OclEndif       51  (MathOclLogic)    nil nil ("MathOclendif"))
    (OclLet         52  (MathOclLogic)    nil nil ("MathOclLet"))
    (OclIn          53  (MathOclLogic)    nil nil ("MathOclIn"))
    (OclEnd         54  (MathOclLogic)    nil nil ("MathOclEnd"))
    (OclFalse       55  (MathOclLogic)    nil nil ("MathOclFalse"))
    (OclTrue        56  (MathOclLogic)    nil nil ("MathOclTrue"))
    (OclUndefined   57  (MathOclVoid)    nil nil ("MathOclUndefined"))
    (OclStrictEq    58  (MathOclOclAny)   nil nil ("MathOclStringEq"))
    (OclStrictNeq   59  (MathOclOclAny)   nil nil ("MathOclStrictNeq"))

    (OclStrongeq     60  (MathOclOclAny)   nil nil ("MathOclStrongEq"))
    (OclStrongNeq    61  (MathOclOclAny)   nil nil ("MathOclStrongNEq"))
    (OclRefEq        62  (MathOclOclAny)   nil nil ("MathOclRefEq"))
    (OclRefNeq       63  (MathOclOclAny)   nil nil ("MathOclRefNeq"))
    (OclIsDefined    64  (MathOclOclAny)   nil nil ("MathOclIsDefined"))
    (OclIsUndefined  65  (MathOclOclAny)   nil nil ("MathOclIsUndefined"))
    (OclAsType       66  (MathOclOclAny)   nil nil ("MathOclAsType"))
    (OclIsType       67  (MathOclOclAny)   nil nil ("MathOclIsType"))
    (OclIsKindOf     68  (MathOclOclAny)   nil nil ("MathOclIsKindOf"))
    (OclAllInstances 69  (MathOclOclAny)   nil nil ("MathOclAllInstances"))

    (OclPlus         70  (MathOclNumerals)  nil nil ("MathOclPlus"))
    (OclMinus        71  (MathOclNumerals)   nil nil ("MathOclMinus"))
    (OclMult         72  (MathOclNumerals)    nil nil ("MathOclMult"))
    (OclNegate       73  (MathOclNumerals)    nil nil ("MathOclNegate"))
    (OclDivision     74  (MathOclNumerals)    nil nil ("MathOclDivision"))
    (OclAbsLeft      75  (MathOclNumerals)    nil nil ("MathOclAbsLeft"))
    (OclAbsRight     76  (MathOclNumerals)    nil nil ("MathOclAbsRight"))
    (OclSizeRight    77  (MathOclCollection) nil nil ("MathOclSizeRight"))
    (OclSizeLeft     78  (MathOclCollection) nil nil ("MathOclSizeLeft"))
    (OclMax          79  (MathOclNumerals)    nil nil ("MathOclMax"))

    (OclMin          80  (MathOclNumerals)    nil nil ("MathOclMin"))
    (OclLess         81  (MathOclNumerals)    nil nil ("MathOclLess"))
    (OclGreater      82  (MathOclNumerals)    nil nil ("MathOclGreater"))
    (OclLessEq       83  (MathOclNumerals)     nil nil ("MathOclLessEq"))
    (OclGreaterEq    84  (MathOclNumerals)     nil nil ("MathOclGreaterEq"))
;    (Ocl          85  (MathOclNumeral)     nil nil ("MathOcl"))
    (OclDiv          86  (MathOclNumerals)     nil nil ("MathOclDiv"))
    (OclMod          87  (MathOclNumerals)     nil nil ("MathOclMod"))
    (OclConcat       88  (MathOclString)      nil nil ("MathOclConcat"))
    (OclSubstring    89  (MathOclString)      nil nil ("MathOclSubstring"))

    (OclToInteger    90  (MathOclString)      nil nil ("MathOclToInteger"))
    (OclToReal       91  (MathOclString)      nil nil ("MathOclToReal"))
    (OclToUpper      92  (MathOclString)      nil nil ("MathOclToUpper"))
    (OclToLower      93  (MathOclString)      nil nil ("MathOclToLower"))

    (OclValid        94  (MathOclLogic)       nil nil ("MathOclValid"))
    (OclOr           95  (MathOclLogic)       nil nil ("OclOr"))
    (OCLSor          96  (MathOclLogic)       nil nil ("OclSor"))
    (OCLAnd          97  (MathOclLogic)       nil nil ("OclAnd"))
    (OCLSAnd         98  (MathOclLogic)       nil nil ("OclSand"))
    (OCLXor          99  (MathOclLogic)       nil nil ("OclXor"))

    (OCLSxor        100  (MathOclLogic)       nil nil ("OclSxor"))
    (OclNot         101  (MathOclLogic)       nil nil ("OclNot"))
    (OclIncludes    102  (MathOclCollection)  nil nil ("OclIncludes"))
    (OCLExcludes    103  (MathOclCollection)  nil nil ("OclExcludes"))
    (OclCount       104 (MathOclCollection)   nil nil ("MathOclCount"))
    (OclIndludesAll 105 (MathOclCollection)   nil nil ("MathOclIncludesAll"))
 ;   (OCL_ 106 (MathOclSymbol) nil nil ("MathOclSupSetEq"))
    (OclExcludesAll 107 (MathOclCollection)   nil nil ("MathOclExcludesAll"))
    (OclIsEmpty     108 (MathOclCollection)   nil nil ("MathOclIsEmpty"))
    (OclIsNotEmpty  109 (MathOclCollection)   nil nil ("MathOclIsNotEmpty"))

    (OclSum           110 (MathOclCollection)   nil nil ("MathOclSum"))
    (OclProduct       111 (MathOclCollection)   nil nil ("MathOclProduct"))
    (OclEmptySet      112 (MathOclCollection)   nil nil ("MathOclEmptySet"))
    (OclUnion         113 (MathOclCollection)   nil nil ("MathOclUnion"))
    (OclIntersection  114 (MathOclCollection) nil nil ("MathOclIntersection"))
    (OclComplement    115 (MathOclCollection) nil nil ("MathOclComplement"))
    (OclSymDifference 116 (MathOclCollection) nil nil ("MathOclSymDifference"))
    (OclFlattenLeft   117 (MathOclCollection) nil nil ("MathOclFlattenLeft"))
    (OclFlattenRight  118 (MathOclCollection) nil nil ("MathOclFlattenRight"))
    (OclAsSet         119 (MathOclCollection) nil nil ("MathOclAsSet"))

    (OclAsOrderedSet  120 (MathOclCollection) nil nil ("MathOclAsOrderedSet"))
    (OclAsBag         121 (MathOclCollection) nil nil ("MathOclAsBag"))
    (OclAsSequence    122 (MathOclCollection) nil nil ("MathOclAsSequence"))
 ;  (Ocl_ 123 (MathOclCollection) nil nil ("MathOcl"))
    (OclAppend        124 (MathOclCollection) nil nil ("MathOclAppend"))
    (OclPrepend       125 (MathOclCollection) nil nil ("MathOclPrepend"))
    (OclInsertAt      126 (MathOclCollection) nil nil ("MathOclInsertAt"))
    ;; Caution: range 127-159 is forbidden
    (OclSubOrderedSet 160 (MathOclCollection) nil nil ("MathOclSubOrderedSet"))
    (OclAt            161 (MathOclCollection) nil nil ("MathOclAt"))
    
    (OclIndexOf       162 (MathOclCollection) nil nil ("MathOclIndexOf"))
    (OclFirst         163 (MathOclCollection) nil nil ("MathOclFirst"))
    (OclLast          164 (MathOclCollection) nil nil ("MathOclLast"))
    (OclSubSequence   165 (MathOclCollection) nil nil ("MathOclSubSequence"))
    (OclBagLeft       166 (MathOclCollection)   nil nil ("MathOclBagLeft"))
    (OclBagRight      167 (MathOclCollection)   nil nil ("MathOclBagRight"))
    (OclEmptyBag      168 (MathOclCollection)   nil nil ("MathOclEmptyBag"))
    (OclSequenceLeft  169 (MathOclCollection)   nil nil ("MathOclSequenceLeft"))
    (OclSequenceRight 170 (MathOclCollection)   nil nil ("MathOclSequenceRight"))
    (OclEmptySequence 171 (MathOclCollection)   nil nil ("MathOclEmptySequence"))
    
    (OclSetLeft       172 (MathOclCollection)   nil nil ("MathOclSetLeft"))
    (OclSetRight      173 (MathOclCollection)   nil nil ("MathOclSetRight"))
;   (Ocl_ 142 (MathOclCollection) nil nil ("MathOcl"))
    (OclOrderedSetLeft  175 (MathOclCollection) nil nil ("MathOclOrderedSetLeft"))
    
    (OclOrderedSetRight 176 (MathOclCollection) nil nil ("MathOclOrderedSetRight"))
    (OclEmptyOrderedSet 177 (MathOclCollection) nil nil ("MathOclEmptyOrderedSet"))
    (OclForall          178 (MathOclLogic)      nil nil ("MathOclForall"))
    (OclExists          179 (MathOclLogic)      nil nil ("MathOclExists"))
    (OclIsUnique        180 (MathOclCollection) nil nil ("MathOclIsUnique"))
    (OclOne             181 (MathOclCollection) nil nil ("MathOclOne"))
    
    (OclAny             182 (MathOclCollection) nil nil ("MathOclAny"))
    (OclCollect         183 (MathOclCollection) nil nil ("MathOclCollect"))
    (OclSelect          184 (MathOclCollection) nil nil ("MathOclSelect"))
    (OclReject          185 (MathOclCollection) nil nil ("MathOclReject"))
    (OclSelectLeft      186 (MathOclCollection) nil nil ("MathOclSelectLeft"))
    (OclSelectRight     187 (MathOclCollection) nil nil ("MathOclSelectRight"))
    (OclRejectRight     188 (MathOclCollection) nil nil ("MathOclRejectRight"))
    (OclRejectLeft      189 (MathOclCollection) nil nil ("MathOclRejectLeft"))
    (OclCollectLeft     190 (MathOclCollection) nil nil ("MathOclCollectLeft"))
    (OclCollectRight    191 (MathOclCollection) nil nil ("MathOclCollectRight"))
    
    (OclCollectNestedLeft  192 (MathOclCollection) nil nil ("MathOclCollectNestedLeft"))
    (OclCollectNestedRight 193 (MathOclCollection) nil nil ("MathOclCollectNestedRight"))
    (OclSortedBy           194 (MathOclCollection) nil nil ("MathOclSortedBy"))
    (OclStrictSVE          195 (MathOclOclAny) nil nil ("MathOclStrictVE"))
    (OclStrongSVE          196 (MathOclOclAny) nil nil ("MathOclSrongVE"))
    (OclStrictDVE          197 (MathOclOclAny) nil nil ("MathOclStrictDeepVe"))
    (OclStrongDVE          198 (MathOclOclAny) nil nil ("MathOclStrongDeepVE"))
    )
  "Table for registry HOL-OCL-font, see `x-symbol-init-cset'.")


(defvar x-symbol-holocl0-fonts
  '("-holocl-holocl0%s-medium-r-normal--%d-%d0-75-75-p-*-adobe-fontspecific"
    "-adobe-symbol%s-medium-r-normal-*-*-%d0-*-*-*-*-adobe-fontspecific")
  "Fonts with registry/encoding \"adobe-fontspecific\".
See `x-symbol-holocl0-cset' and `x-symbol-init-cset'.")

(defvar x-symbol-holocl0-cset
  '((("adobe-fontspecific") ?\234 -3600)
    (holocl0-left  "HOL-OCL characters 0, left"  94 ?:) .
    (holocl0-right "HOL-OCL characters 0, right" 94 ?\;))
  "Cset with registry \"fontspecific\", see `x-symbol-init-cset'.")



(x-symbol-init-cset x-symbol-holocl0-cset x-symbol-holocl0-fonts
                      x-symbol-holocl0-table)


(defvar x-symbol-holocl1-fonts
  '("-holocl-holocl1%s-medium-r-normal--%d-%d0-75-75-p-*-holocl-holocl1")
  "Fonts with registry/encoding \"holocl-holocl1\".
See `x-symbol-holocl1-cset' and `x-symbol-init-cset'.")


(defvar x-symbol-holocl1-cset
  '((("holocl-holocl1") ?\235 -3500)
    (holocl1-left  "HOL-OCL characters 1, left"  94 ?<) .
    (holocl1-right "HOL-OCL characters 1, right" 96 ?=))
  "Cset with registry \"holocl1\", see `x-symbol-init-cset'.")


(x-symbol-init-cset x-symbol-holocl1-cset x-symbol-holocl1-fonts
		      x-symbol-holocl1-table)


(defface holocl-MathOcl-class-name-face
  '((((type x) (class color) (background light))
     (:foreground "DeepPink"))
    (((type x) (class color) (background dark))
     (:foreground "DeepPink"))
    (t
     (bold t)))
  "*Face for MathOCL term highlighting"
  :group 'hol-ocl-faces)

(defconst holocl-MathOcl-class-name-face 'holocl-MathOcl-class-name-face)

(defvar ocl-token-keyword-list  
  '( 
;    ; holocl0 7680+code (1E00+code)
;    ("\\([\x1e22]\\)"  1 holocl-MathOcl-class-name-face t) ; 34
;    ("\\([\x1e24]\\)"  1 holocl-MathOcl-class-name-face t) ; 36
;    ("\\([\x1e5e]\\)"  1 holocl-MathOcl-class-name-face t) ; 94
;    ("\\([\x1e64]\\)"  1 holocl-MathOcl-class-name-face t) ; 100
;    ("\\([\x1e75]\\)"  1 holocl-MathOcl-class-name-face t) ; 117
;    ("\\([\x1eb6]\\)"  1 holocl-MathOcl-class-name-face t) ; 182
;    ("\\([\x1ec5-\x1ec8]\\)"  1 holocl-MathOcl-class-name-face t) ; 197-200
;    ("\\([\x1ece-\x1ecf]\\)"  1 holocl-MathOcl-class-name-face t) ; 206-207
;    ("\\([\x1ed8-\x1eda]\\)"  1 holocl-MathOcl-class-name-face t) ; 216-218
    ;
    ; holocl1 7936/0x1F00 + code
    ("\\([\x1f21-\x1f7e]\\)"  1 holocl-MathOcl-class-name-face  t) ;  33-126
    ("\\([\x1fa0-\x1fff]\\)"  1 holocl-MathOcl-class-name-face  t) ; 160-255
    )
  )



(font-lock-add-keywords 'isar-mode  ocl-token-keyword-list  )
(font-lock-add-keywords 'isar-goals-mode  ocl-token-keyword-list  )
(font-lock-add-keywords 'isar-shell-mode  ocl-token-keyword-list  )
(font-lock-add-keywords 'isar-response-mode  ocl-token-keyword-list  )
 
