(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * isp.thy - 
 * Copyright (C) 2005 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                                                            
 * This File is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)


header {* Internet Service Provider *}

theory isp 
imports
  OCL
begin

ML {* val _ = writeInfoFile "/tmp/holoclinfo.txt" *}
text  {* \verbatiminput {/tmp/holoclinfo.txt} *}

text {* 
Assume the following scenario in our model of the ISP: The ISP wants
to offer three services (1 GB, 10 GB, 100 GB download/per month). So
the customer chooses one of these services. According to his selection
he can download the selected amount of data per month. In case he
downloads more, he will be charged for it separately. In case the
customer does not pay his bill, the ISP will disable the service for
this customer.  Model the involved concepts and the relationships
between them in a class diagram (on a con- ceptual) level, using the
following classes: Services, Customer, Bill, Surf-Record, Provider
Important: In your model the three use cases Charge Customer, Disable
Customer (in case the customer did not pay his bill) and Change
Service (the customer wants to change to a different service class)
should be included.
*}

text {*
%\begin{table}
\begin{small}
\lstinputlisting[style=ocl]{isp.ocl}
\end{small}
%\caption{OCL specification\label{tab:isp_ocl}} 
%\end{table}

\begin{figure}
\begin{center}
\rotatebox{90}{\includegraphics[scale=.7]{isp}}
\end{center}
\caption{A simple Class Diagramm\label{fig:isp_classdiag}}
\end{figure}

*}


load_xmi "isp_ocl.xmi"

end
