(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * OCL_Library.thy - OCL Library
 * Copyright (C) 2001-2006 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                         Burkhart Wolff   <bwolff@inf.ethz.ch>    
 *                                                                            
 * This file is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)
header {* The \OCL Library*}

theory OCL_Library  
imports 
  "$HOLOCL_HOME/src/library/collection/$COLLECTION/OCL_CharactersticSet"
begin
 text_raw{* \label{thy:OCL_Library} *}

section {* Datatype Conversions *}
consts
  HolOclToReal     :: "'a Integer => 'a Real"         ("_ ->toReal'( ')" [66])
defs
  HolOclToReal_def:
  "HolOclToReal        \<equiv> lift\<^sub>1(strictify(\<lambda> x\<Colon>Integer_0. 
                         \<HolOclLiftLeft> real ( \<HolOclDropLeft>x\<HolOclDropRight> ) \<HolOclLiftRight> ))"
end
