(* ****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * OCL_Set_type.thy - Type Definition for Set
 * Copyright (C) 2001-2006 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                         Burkhart Wolff   <bwolff@inf.ethz.ch>    
 *                                                                            
 * This file is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNES 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ***************************************************************************** *)

header {* Type Definition for Set *}
theory OCL_Set_type 
imports 
  "$HOLOCL_HOME/src/library/collection/OCL_Collection_type"
begin
 text_raw{* \label{thy:OCL_Set_type} *}
typedef  'a Set_0 = "{X::('a\<Colon>bot) set up. 
                     (smash (\<lambda>x X. DEF X \<and> x \<in> drop X) X) = X}"
apply (rule_tac x="\<bottom>" in exI)
  by (simp add: smash_def)

instance Set_0 :: (type) ord
  by intro_classes

arities  Set_0 :: (type) collection   (* declares Set as a Collection *)

defs     UU_Set_def: "\<bottom> \<equiv> Abs_Set_0 down"

end
